import os
from os.path import join
import sys
from time import time

from pycompss.api.task import task
from pycompss.api.binary import binary
from pycompss.api.constraint import constraint
from pycompss.api.mpi import mpi
from pycompss.api.api import compss_wait_on
from pycompss.api.api import compss_barrier
from pycompss.api.parameter import *


# in the container
# date
# mpirun --allow-run-as-root --mca btl_vader_single_copy_mechanism none -n 2  fesom.x
# date

# in MN4
# mpirun -n 2  ./fesom.x

# TODO: check how to properly configure the JSON file, also which version of COMPSs supports these new decorators
#@Software(esm.json)
#enqueue_compss -t --qos=debug  --log_level=debug  --job_name=fesom2 --max_tasks_per_node=2 --exec_time=20 --num_nodes=1 --pythonpath=$PWD  esm_simulation.py

# working decorator in MN4 - pi dataset
# @mpi(binary="/home/bsc32/bsc32044/fesom_hecuba/work_pi/fesom.x", runner="mpirun", processes="2", working_dir="/home/bsc32/bsc32044/fesom_hecuba/work_pi", fail_by_exit_value=True)

# not working core2 - 288 cores
# enqueue_compss -t  --qos=debug --log_level=debug  --job_name=fesom2 --cpus_per_node=288 --exec_time=30 --num_nodes=6 --pythonpath=$PWD  esm_simulation.py

@mpi(binary="fesom.x", runner="srun", processes="2", working_dir="." , fail_by_exit_value=True)
@task(log_file={Type:FILE_OUT, StdIOStream:STDOUT})
def esm_simulation(log_file):
    pass

if __name__ == "__main__":
    print("Running FESOM2 - pi dataset")
    log_file = "fesom2_log.out"
    esm_simulation(log_file)
